//
// Squish Compressor by SSJX (https://ssjx.co.uk)
//
// Port of a C program that compressed files for the Cybiko Handheld Computer.
//
// Work in progress so lot of diag / debug code still present!
//

import std.stdio;
import std.conv;	// to!string()
import std.File;
import std.path;	// baseName

import std.datetime.stopwatch;
import compress;

// size 6
struct my_header{
	align(1):
	char[4] id;
	short files; //
}

// Size 18
struct my_files{
	align(1):
	short comp;
	uint jnk;   // Space 
	uint csize; // Compressed size
	uint jnka;  // Space
	uint osize; // Original size
}

bool contains(char[] haystack,char needle){
	foreach(c;haystack){
		if (c==needle){return true;}
	}

	return false;
}

void main(string[] args){
	auto action=-1;
	string fn="";
	
	writeln("Squish v0.2 D (10/02/24) by ssjx (https://ssjx.co.uk)");
	writeln("-----------------------------------------------------");
	
	if (args.length>1){
		foreach(par;args){
			if (par[0]=='-'){
				if (par=="-c"){action=0;}
				if (par=="-d"){action=1;}
			}else{
				if (par!=args[0]){
					// Not the exe or an option so probably a file
					fn=par;
				}
			}
		}
	}
	
	
	if (action==-1){
		writeln("Usage: squish [option] myfile.sqh");
		writeln("Options:");
		writeln("\t-c\tCompress (saved as output.sqh)");
		writeln("\t-d\tDecompress (file extracted with saved name and ext_ prefix)");
		return;
	}
	
	if (exists(fn)==false){
		writeln("Cannot find file ",fn);
		return;
	}
	
	gencodes(false);
	ubyte[] output;
	my_header[1] fheader;
	my_files[1] myfile;
	uint[1] fnlen;
		
	switch(action){
	case 0:
		// Compress
		auto txtinput=read(fn);
		//
		StopWatch sw;
		sw.start();
		
		bool success=go_compress(cast(ubyte[])txtinput,output);
		
		long msecs = sw.peek.total!"msecs";
		writeln("Elapsed time: ",msecs,"ms");
	
		if (success==false){
			writeln("Compression failed!");
		}
	
		//
		// Write to file
		//
	
		
		
		// Write header (new v2 header!)
		fheader[0].id="cyf2";
		fheader[0].files=1;
		
		//Info about the file 
		myfile[0].comp=1; // 0=raw 
		myfile[0].jnk=0;
		myfile[0].jnka=0;
		myfile[0].osize=txtinput.length;
		
		string outfn="output.sqh";
		File outfile = File(outfn, "wb");   	
		writeln("Saving as ",outfn,"...");
		
		outfile.rawWrite(fheader);
		outfile.rawWrite(myfile);

		// Write size and filename (remove path)
		string testname=baseName(fn);
		fnlen[0]=testname.length;

		outfile.rawWrite(fnlen);
		outfile.rawWrite(testname);
		
		// Write size and table	
		ubyte[] letters_only;
		foreach(b;bytelist){
			letters_only~=b.letter;
		}
		
		fnlen[0]=letters_only.length;
		outfile.rawWrite(fnlen);
		outfile.rawWrite(letters_only);

		// Write size and data	
		fnlen[0]=output.length;
		outfile.rawWrite(fnlen);	
		outfile.rawWrite(output);
		outfile.close();
	break;
	
	case 1:
		// Decompress
		File file = File(fn, "rb");
		file.rawRead(fheader);
		file.rawRead(myfile);

		// Real file name
		file.rawRead(fnlen);	
		char[] testname;
		testname.length=fnlen[0];
		file.rawRead(testname);

		// Table
		file.rawRead(fnlen);
		ubyte[] letters_only;
		letters_only.length=fnlen[0];
		file.rawRead(letters_only);
		// writeln("Letters:\t",letters_only);

		// Data
		file.rawRead(fnlen);
		output.length=fnlen[0];
		file.rawRead(output);
		// writeln("Output:\t",output);

		// Decompress
		foreach(i;0..letters_only.length){
			node[i].value=letters_only[i];
			
			// uint tv=(va &0xffffffff)<<24;
			// write("-");
			// showbits(tv,8);
			// writeln;
			
		}
		
		//
		ubyte[] message;
		
		StopWatch sw;
		sw.start();
			
			go_decompress(output,message);
			// slow_decompress(output,message);
		
		long msecs = sw.peek.total!"msecs";
		writeln("Elapsed time: ",msecs,"ms");
		
		
		string outfn="ext_"~to!string(testname);
		File outfile = File(outfn, "wb");   	
		writeln("Saving as ",outfn,"...");
		outfile.rawWrite(message);
		outfile.close();
	break;
	
	default:
		writeln("Unknown action");
	break;
	}
}
